# BenchSort.py
""" Module for comparing the efficiency of
merge Sort and Selection sort.
"""


from timeit import *

# The set-up code is placed in a doc string.

OurSetUpCode = '''
from random import randint as randi
from ShowMergeSort import MergeSort
from ShowSelect import SelectionSort

n = 10000
b = [randi(0,10*n) for i in range(n)]
'''

# Benchmark codes, 

BenchSelectionSort = """
a = list(b)
SelectionSort(a)
"""

BenchMergeSort = """
u = MergeSort(b)
"""


# m is the number of times the benchmark code is run for
# each timing. Because of clock granularity, larger values
# are needed for benchmark codes that runn very quickly

m = 1

# p is the number of timings that are run. Larger values
# help insure among the timings there will one that accurately
# reflects the true running time.(Background activity on the computer
# might diminish perfromance.

p = 3

n = 10000

print '\nTimes for SelectionSort with n = %1d' % n
tSelectTimes = Timer(BenchSelectionSort, setup=OurSetUpCode).repeat(p,m)
for k in range(p):
    print '  %8.5f' % tSelectTimes[k]
    
print '\nTimes for MergeSort with n = %1d' % n
tMergeSortTimes = Timer(BenchMergeSort, setup=OurSetUpCode).repeat(p,m)
for k in range(p):
    print '  %8.5f' % tMergeSortTimes[k]
    

